unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, OleCtrls, Roger_RemoteMon_TLB, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    GroupBox1: TGroupBox;
    Panel2: TPanel;
    rm: TRoger_RemoteMonitor;
    GroupBox2: TGroupBox;
    ButtonConnect: TButton;
    ButtonDisconnect: TButton;
    ButtonGET_ReaderNamesXML: TButton;
    ButtonGET_UsersXML: TButton;
    ButtonGET_SubsystemsXML: TButton;
    ButtonOpenDoor: TButton;
    Edit_IDDoor: TEdit;
    ButtonEntire_AllControllersToON: TButton;
    ButtonAbout: TButton;
    ButtonEntire_AllControllersToOFF: TButton;
    ButtonLoginWindow: TButton;
    CheckBoxShowMessage: TCheckBox;
    CheckBoxShowErrorMessage: TCheckBox;
    ButtonClearEventList: TButton;
    ButtonClearAlarmList: TButton;
    GroupBox3: TGroupBox;
    Memo1: TMemo;
    ButtonAPI: TButton;
    Button1: TButton;
    Edit_UserID: TEdit;
    ButtonGET_UsersLastLoginXML: TButton;
    ButtonGET_ControllersStatesXML: TButton;
    Button2: TButton;
    procedure ButtonConnectClick(Sender: TObject);
    procedure ButtonDisconnectClick(Sender: TObject);
    procedure ButtonGET_ReaderNamesXMLClick(Sender: TObject);
    procedure ButtonGET_UsersXMLClick(Sender: TObject);
    procedure ButtonGET_SubsystemsXMLClick(Sender: TObject);
    procedure ButtonOpenDoorClick(Sender: TObject);
    procedure ButtonEntire_AllControllersToONClick(Sender: TObject);
    procedure ButtonAboutClick(Sender: TObject);
    procedure ButtonEntire_AllControllersToOFFClick(Sender: TObject);
    procedure ButtonLoginWindowClick(Sender: TObject);
    procedure rm_OnDisconnect(Sender: TObject);
    procedure rm_OnErrorMessage(ASender: TObject; const str: WideString);
    procedure rm_OnMessage(ASender: TObject; const str: WideString);
    procedure rm_OnMonitorEvent(ASender: TObject; const xml: WideString);
    procedure rm_OnUpdateSubsPanels(ASender: TObject;
      const xml: WideString);
    procedure ButtonClearEventListClick(Sender: TObject);
    procedure ButtonClearAlarmListClick(Sender: TObject);
    procedure CheckBoxShowMessageClick(Sender: TObject);
    procedure CheckBoxShowErrorMessageClick(Sender: TObject);
    procedure ButtonAPIClick(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure rm_OnConnect(ASender: TObject; const info: WideString);
    procedure Button1Click(Sender: TObject);
    procedure rm_OnUpdateUserLogin(ASender: TObject;
      const XML: WideString);
    procedure ButtonGET_UsersLastLoginXMLClick(Sender: TObject);
    procedure ButtonGET_ControllersStatesXMLClick(Sender: TObject);
    procedure rm_OnUpdateControllerState(ASender: TObject;
      const XML: WideString);
    procedure Button2Click(Sender: TObject);
  private
    { Private declarations }
    isConnecting: Boolean;
    procedure OpenInBrowser(xml: String);
    procedure InsertLine;
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

uses API, shellapi;

{$R *.dfm}

procedure TForm1.ButtonConnectClick(Sender: TObject);
begin
  rm._Connected := true;
end;

procedure TForm1.ButtonDisconnectClick(Sender: TObject);
begin
  rm._Connected := false;
end;

procedure SaveToFile(xml: String);
var sl: TStringList;
begin
  sl := TStringList.Create;
  sl.Text := xml;
  sl.Insert(0, '<?xml version="1.0" encoding="windows-1250" ?> ');
  sl.SaveToFile('TEST.XML');
  sl.Free;
end;

procedure TForm1.ButtonGET_ReaderNamesXMLClick(Sender: TObject);
var xml: String;
begin
  xml := rm._GET_ReaderNamesXML;
  SaveToFile(xml);
  OpenInBrowser(xml);
end;

procedure TForm1.ButtonGET_UsersXMLClick(Sender: TObject);
var xml: String;
begin
  xml := rm._GET_UsersXML;
  SaveToFile(xml);
  OpenInBrowser(xml);
end;

procedure TForm1.ButtonGET_SubsystemsXMLClick(Sender: TObject);
var xml: String;
begin
  xml := rm._GET_SubsystemsXML;
  SaveToFile(xml);
  OpenInBrowser(xml);
end;

procedure TForm1.ButtonOpenDoorClick(Sender: TObject);
begin
  rm._Controller_OpenDoor( StrToInt(Edit_IDDoor.Text) );
end;

procedure TForm1.ButtonEntire_AllControllersToONClick(Sender: TObject);
begin
  rm._Entire_AllControllersToON;
end;

procedure TForm1.ButtonAboutClick(Sender: TObject);
begin
  rm.AboutBox;
end;

procedure TForm1.ButtonEntire_AllControllersToOFFClick(Sender: TObject);
begin
  rm._Entire_AllControllersToOFF;
end;

procedure TForm1.ButtonLoginWindowClick(Sender: TObject);
begin
  rm._ConnectToPrMaster('','');
end;

procedure TForm1.InsertLine();
begin
  Memo1.Lines.Insert(0,'---------------------------------');
end;

procedure TForm1.rm_OnDisconnect(Sender: TObject);
begin
  isConnecting := false;
  Memo1.Lines.Insert(0,'OnDisconnect');
  InsertLine();
end;

procedure TForm1.rm_OnErrorMessage(ASender: TObject;
  const str: WideString);
begin
  Memo1.Lines.Insert(0,'OnErrorMessage: '+str);
  InsertLine();
end;

procedure TForm1.rm_OnMessage(ASender: TObject; const str: WideString);
begin
  Memo1.Lines.Insert(0,'OnMessage: '+str);
  InsertLine();
end;

procedure TForm1.rm_OnMonitorEvent(ASender: TObject;
  const xml: WideString);
begin
  Memo1.Lines.Insert(0,'OnMonitorEvent (XML): '+xml);
  InsertLine();
end;

procedure TForm1.rm_OnUpdateSubsPanels(ASender: TObject;
  const xml: WideString);
begin
  Memo1.Lines.Insert(0,'OnUpdateSubsPanels (XML): '+xml);
  InsertLine();
end;

procedure TForm1.ButtonClearEventListClick(Sender: TObject);
begin
  rm._ClearEventList;
end;

procedure TForm1.ButtonClearAlarmListClick(Sender: TObject);
begin
  rm._ClearAlarmList;
end;

procedure TForm1.CheckBoxShowMessageClick(Sender: TObject);
begin
  rm._ShowMessage := CheckBoxShowMessage.Checked;
end;

procedure TForm1.CheckBoxShowErrorMessageClick(Sender: TObject);
begin
  rm._ShowErrorMessage := CheckBoxShowErrorMessage.Checked;
end;

procedure TForm1.ButtonAPIClick(Sender: TObject);
begin
  FormAPI.RichEdit1.Lines.LoadFromFile(
      ExtractFilePath(Application.ExeName) + '\doc\Kontrolka ActiveX Roger.rtf');
  FormAPI.Show;
end;

procedure TForm1.FormShow(Sender: TObject);
begin
  WindowState := wsMaximized;
end;

procedure TForm1.FormCreate(Sender: TObject);
var conf: TStringList;
    fileName: String;
    ip, port: String;
begin
  conf := TStringList.Create;
  try
    fileName := ChangeFileExt( Application.ExeName, '.tcp' );
    if not FileExists( fileName ) then begin
      MessageDlg('Brak pliku konfiguracyjnego "'+fileName+'" dla poczenia TCP z PRMaster.'#13+
        'Przyjto ustawienia domylne IP:127.0.0.1  PORT:64181'
        ,mtWarning, [mbOK], 0);
      Exit;
    end
    else begin
      conf.LoadFromFile( fileName );

      ip := conf.Values['IP'];
      port := conf.Values['PORT'];

      rm._PRMasterHostIP := ip;
      rm._PRMasterHostPort := StrToInt( port );
    end;
  finally
    conf.Free;
  end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
  if isConnecting then begin
    CanClose := false;
    ShowMessage('Najpierw musisz si rozczy z serwerem PRMaster!');
  end
  else
    CanClose := true;
end;

procedure TForm1.rm_OnConnect(ASender: TObject; const info: WideString);
begin
  isConnecting := true;
  Memo1.Lines.Insert(0,'OnConnect (info): '+info);
  InsertLine();
end;

procedure TForm1.Button1Click(Sender: TObject);
var xml: String;
begin
  xml := rm._GET_UserXML[ StrToInt(Edit_UserID.Text) ];
  SaveToFile(xml);
  OpenInBrowser(xml);
end;

procedure TForm1.OpenInBrowser(xml: String);
begin
  ShellExecute(Handle, 'open', 'TEST.XML', nil, nil, SW_SHOWNORMAL);
end;

procedure TForm1.rm_OnUpdateUserLogin(ASender: TObject; const XML: WideString);
begin
  Memo1.Lines.Insert(0,'OnUpdateUserLogin (XML): '+xml);
  InsertLine();
end;

procedure TForm1.ButtonGET_UsersLastLoginXMLClick(Sender: TObject);
var xml: String;
begin
  xml := rm._GET_UsersLastLoginXML;
  SaveToFile(xml);
  OpenInBrowser(xml);
end;

procedure TForm1.ButtonGET_ControllersStatesXMLClick(Sender: TObject);
var xml: String;
begin
  xml := rm._GET_ControllersStatesXML;
  SaveToFile(xml);
  OpenInBrowser(xml);
end;


procedure TForm1.rm_OnUpdateControllerState(ASender: TObject; const XML: WideString);
begin
  Memo1.Lines.Insert(0,'OnUpdateControllerState (XML): '+xml);
  InsertLine();
end;

procedure TForm1.Button2Click(Sender: TObject);
var i: Integer;
    s: WideString;
begin


  for i := 1 to 100 do begin
    Memo1.Lines.Insert(0,'>> BEFORE: _Tools_UpdateUserXML: '+IntToStr(i));
    InsertLine();

    rm._Tools_AddNewUserXML(48, false, '<user><firstName>TEST</firstName><lastName>Ble'+IntToStr(i)+'_' + TimeToStr(Now)+'</lastName><userName>Ble ble</userName><official>False</official><active>True</active><custom1>11111</custom1><custom2>22222</custom2>'+
      '<custom3>333</custom3><custom4>444444</custom4><evidence></evidence><status>NORMAL</status><transponderCode></transponderCode><keyboardCode></keyboardCode><photo></photo><group enable="True" selName="[No group]">'+
      '<name>Bez grupy</name></group><activityPeriodOn>False</activityPeriodOn><activitySince>1899/12/30</activitySince><activityUntil>1899/12/30</activityUntil></user>');
    s := rm._GET_UsersXML;
    if s = '' then
      ShowMessage('!!! > ' + IntTostr(i));

    Memo1.Lines.Insert(0,'>> AFTER: _Tools_UpdateUserXML: '+IntToStr(i));
    InsertLine();

  end;
end;

end.
